
'S2 include code version 2010.11.18

'---[Constants]----------------------------------------------------------------

CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  EE_REFLIGHTS  = s2#EE_USER_AREA
  LINE_THLD     = 32
  BAR_THLD      = 32
  OBSTACLE_THLD = 20
  SPKR_VOL      = 35

'---[Global Variables]---------------------------------------------------------

VAR

  long  CoinFlip, LeftMotor, RightMotor, MoveTime, pLeftMotor, pRightMotor, pMoveTime, FMStack[50]
  word  WheelSpace, FullCircle, SeqCounter
  byte  LeftLight, CenterLight, RightLight, RefLights[3]
  byte  ResetCount, LineCount, ObstacleCount, StallCount, ObstacleThld
  byte  LineThld, LeftLine, RightLine, LeftObstacle, RightObstacle, Self
  byte  Flag_green, Flag_yellow, Flag_orange, Flag_red, Flag_magenta, Flag_purple, Flag_blue, Stalled

'---[Object Declaration]-------------------------------------------------------

OBJ

  s2    : "S2"
  s2T    : "S2T"
'---[Start of Program]---------------------------------------------------------

PUB start


  s2.start_motors
  s2T.start_tones

  \Green
  repeat


'---[Main Program: Green]------------------------------------------------------

PUB Green

  MotorSet(0, 128, 0)
  PlayNote(183, 293, 0)
  PlayNote(183, 329, 0)
  PlayNote(183, 293, 0)
  PlayNote(366, 391, 0)
  PlayNote(366, 391, 0)
  PlayNote(366, 391, 0)
  s2T.wait_sync(0)
  MotorSet(0, -128, 0)
  PlayNote(183, 293, 0)
  PlayNote(183, 329, 0)
  PlayNote(183, 293, 0)
  PlayNote(366, 391, 0)
  PlayNote(366, 391, 0)
  PlayNote(183, 391, 0)
  s2T.wait_sync(0)
  MotorSet(0, 128, 0)
  PlayNote(183, 293, 0)
  PlayNote(183, 329, 0)
  PlayNote(183, 293, 0)
  PlayNote(366, 391, 0)
  PlayNote(366, 391, 0)
  PlayNote(366, 391, 0)
  s2T.wait_sync(0)
  MotorSet(0, -128, 0)
  PlayNote(117, 329, 0)
  s2T.wait_sync(0)
  MotorSet(0, 128, 0)
  PlayNote(117, 293, 0)
  s2T.wait_sync(0)
  MotorSet(0, -128, 0)
  PlayNote(117, 369, 0)
  s2T.wait_sync(0)
  MotorSet(0, 128, 0)
  PlayNote(117, 349, 0)
  s2T.wait_sync(0)
  MotorSet(0, -128, 0)
  PlayNote(117, 369, 0)
  s2T.wait_sync(0)
  MotorSet(0, 128, 0)
  PlayNote(117, 349, 0)
  s2T.wait_sync(0)
  MotorSet(0, -128, 0)
  PlayNote(117, 369, 0)
  PlayNote(117, 0, 0)
  s2T.wait_sync(0)
  MotorSet(256, -256, 0)
  PlayNote(183, 293, 0)
  PlayNote(183, 369, 0)
  PlayNote(183, 349, 0)
  PlayNote(183, 369, 0)
  PlayNote(183, 349, 0)
  PlayNote(183, 369, 0)
  PlayNote(183, 369, 0)
  PlayNote(183, 329, 0)
  PlayNote(183, 293, 0)
  PlayNote(183, 369, 0)
  PlayNote(183, 349, 0)
  PlayNote(183, 369, 0)
  PlayNote(183, 349, 0)
  PlayNote(183, 369, 0)
  PlayNote(366, 0, 0)
  s2T.wait_sync(0)
  MotorSet(128, 128, 0)
  PlayNote(117, 293, 0)
  s2T.wait_sync(0)
  MotorSet(-128, -128, 0)
  PlayNote(234, 293, 0)
  s2T.wait_sync(0)
  MotorSet(128, 128, 0)
  PlayNote(117, 293, 0)
  s2T.wait_sync(0)
  MotorSet(128, 128, 0)
  PlayNote(234, 329, 0)
  s2T.wait_sync(0)
  MotorSet(-128, -128, 0)
  PlayNote(187, 369, 0)
  s2T.wait_sync(0)
  MotorSet(128, 128, 0)
  PlayNote(187, 391, 0)
  PlayNote(187, 0, 0)
  s2T.wait_sync(0)
  MotorSet(0, 0, 0)

'---[Set Motor Speeds]---------------------------------------------------------

PRI MotorSet(lmotor, rmotor, timer)

  MoveTime := timer #> 0
  LeftMotor := lmotor #> -256 <# 256
  RightMotor := rmotor #> -256 <# 256
  if (LeftMotor <> pLeftMotor or RightMotor <> pRightMotor or MoveTime <> pMoveTime or pMoveTime <> 0)
    if (MoveTime)
      s2.move_now(LeftMotor * MoveTime * FullCircle / 1_024_000, RightMotor * MoveTime * FullCircle / 1_024_000, MoveTime << 1, (||LeftMotor #> ||RightMotor <# 255) >> 4, 0)
      s2.wait_stop
    else  
      s2.wheels_now(LeftMotor, RightMotor, 0)
      waitcnt(cnt + clkfreq / 10)
    pLeftMotor := LeftMotor
    pRightMotor := RightMotor
    pMoveTime := MoveTime

'---[Play an Individual Note, Separated by a Short Delay.]---------------------

PRI PlayNote(duration, freq1, freq2)

  s2T.play_tone(duration - 1 #> 1, freq1, freq2)
  s2T.play_tone(1, 0, 0)

'---[End of Program]-----------------------------------------------------------