//
// automatically generated by spin2cpp v1.92 on Tue Apr 21 11:27:35 2015
// spin2cpp --main --ccode HokeyPokey.spin 
//

// :::::::[ Driver Object for the Scribbler 2 ]:::::::::::::::::::::::::::::::::
/* {
┌───────────────────────────────────────┐
│          Scribbler S2 Object          │
│(c) Copyright 2010 Bueno Systems, Inc. │
│   See end of file for terms of use.   │
└───────────────────────────────────────┘
This object provides both high- and low-level drivers for the
Parallax Scribbler S2 robot.

Version History
───────────────

2010.09.16: Initial Version 1(M) release
2010.09.28: Version 1(N) release:
              Fixed bug in _ee* Spin routines.
              Upped size of sound buffer to 1200.
              Added calibration methods for light sensors.
              Added 1/2 sec. delay to start routine.
2010.10.18:   Added check for zero time in play_tone.
2010.10.25:   Added log response method for light sensors.
2010.10.27: Version 1(O) release:
              Added methods to save default line sensor threshold.
2010.10.28:   Fixed bugs in calibration methods.
2010.11.15: Version 1(P) release:
              Added self-documentation features.
              Added sensitivity setting for obstacle detection.
2010.11.24: Version 1(Q) release:
              Added sample programs to self-documentation.
 */
/* =======[ Introduction ]=========================================================

S2.spin provides low-level drivers for the S2 Robot's various functions, as well as
top-level access functions to interface with those drivers. Driver functions are
separated into four additional cogs:
''
''  1. Analog, button, and LED drivers.
''  2. Motor driver.
''  3. Sound sequencer and synthesizer.
''  4. Microphone envelope detector.
''
Driver #1 is required and is started with the S2 object's main `start method. The
other drivers are optional, depending upon the user's requirements, and have their
own start methods (`start_motors, `start_tones, `start_mic_env). The S2 object's
`stop method stops all driver cogs which have been started.

The analog, button, and LED drivers are the heartbeat of the system. The analog
driver continuously cycles through sixteen analog inputs and updates their states
with a one-millisecond cycle time. The button driver monitors the state
of the S2's single pushbutton and, depending on the user-selected button mode, can
cause it to reset the S2, while displaying the button-press count on the LEDs, and
record the number of button presses in EEPROM for use by the newly-restarted user
program. The LED driver manages the LEDs' polarity and PWMing to provide various
shades and hues from the S2's red/green LEDs and blue power LED. It does this via
the LEDs' shift register port.

 */
// =======[ Constants... ]=========================================================
#include <stdlib.h>
#include <propeller.h>
#include "S2.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#define BitEncode__(X) (32 - __builtin_clz(X))
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
INLINE__ int32_t BitEncode__(uint32_t a) {
  int r=0;
  while (a != 0) { a = a>>1; r++; }
  return r;
}
#endif

INLINE__ int32_t Min__(int32_t a, int32_t b) { return a < b ? a : b; }
INLINE__ int32_t Max__(int32_t a, int32_t b) { return a > b ? a : b; }
INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
static uint32_t Sqrt__(uint32_t a) {
    uint32_t res = 0;
    uint32_t bit = 1<<30;
    while (bit > a) bit = bit>>2;
    while (bit != 0) {
        if (a >= res+bit) {
            a = a - (res+bit);
            res = (res>>1) + bit;
        } else res = res >> 1;
        bit = bit >> 2;
    }
    return res;
}
static  int32_t S2__compute_calibration( S2 *self );
static  int32_t S2__atan2( S2 *self, int32_t y, int32_t x);
static  int32_t S2__ee_rdblock( S2 *self, int32_t dest_addr, int32_t addr, int32_t size);
static  int32_t S2__ee_wrblock( S2 *self, int32_t src_addr, int32_t addr, int32_t size);
static  int32_t S2__ee_rdbyte( S2 *self, int32_t addr);
static  int32_t S2__ee_wrbyte( S2 *self, int32_t addr, int32_t data);
static  int32_t S2__i2c_waddr( S2 *self, int32_t addr);
static  int32_t S2__i2c_rd( S2 *self, int32_t acknak);
static  int32_t S2__i2c_wr( S2 *self, int32_t data);
static  int32_t S2__i2c_start( S2 *self );
static  int32_t S2__i2c_stop( S2 *self );

static uint8_t dat[] = {
  0xfc, 0xec, 0xbf, 0xa0, 0x01, 0xf4, 0xff, 0xa0, 0x01, 0xf6, 0xff, 0xa0, 0xf0, 0x11, 0xbe, 0xa0, 
  0x04, 0x10, 0xfe, 0x80, 0xf0, 0x13, 0xbe, 0xa0, 0x08, 0x12, 0xfe, 0x80, 0xf1, 0x05, 0xbe, 0xa0, 
  0x00, 0x05, 0xbe, 0x80, 0xf2, 0xf5, 0x3d, 0x61, 0x01, 0x20, 0xfe, 0x34, 0xf2, 0xf7, 0x3d, 0x61, 
  0x01, 0x22, 0xfe, 0x34, 0x00, 0x44, 0xfe, 0xa0, 0xb7, 0x96, 0xfd, 0x5c, 0xf0, 0x07, 0x3e, 0x08, 
  0xf0, 0x1b, 0xbe, 0x0a, 0x17, 0x00, 0x54, 0x5c, 0x00, 0xf0, 0xff, 0xa0, 0x00, 0xf2, 0xff, 0xa0, 
  0xb7, 0x96, 0xfd, 0x5c, 0xf0, 0x1b, 0xbe, 0x0a, 0x15, 0x00, 0x68, 0x5c, 0x0d, 0x1d, 0xbe, 0xa0, 
  0x10, 0x1c, 0xfe, 0x2a, 0x04, 0x1a, 0xd6, 0x7c, 0x0d, 0x31, 0xbe, 0xa0, 0x08, 0x30, 0xfe, 0x28, 
  0x0f, 0x30, 0xfe, 0x60, 0x0d, 0x33, 0xbe, 0xa0, 0x04, 0x32, 0xfe, 0x28, 0x0f, 0x32, 0xfe, 0x60, 
  0x08, 0x32, 0xfe, 0x48, 0x0f, 0x1a, 0xfe, 0x60, 0x08, 0x25, 0xbe, 0x0a, 0xf0, 0x07, 0x3e, 0x08, 
  0x12, 0x00, 0x68, 0x5c, 0xf4, 0x17, 0xbe, 0xa0, 0x12, 0x27, 0xbe, 0xa0, 0x10, 0x26, 0xfe, 0x38, 
  0x10, 0x24, 0xfe, 0x2c, 0x10, 0x24, 0xfe, 0x38, 0x12, 0x25, 0xbe, 0xa9, 0xf7, 0x16, 0x8e, 0x6c, 
  0x01, 0x24, 0xfe, 0x2c, 0x01, 0x24, 0xfe, 0x48, 0xf7, 0xe8, 0xbf, 0x74, 0x13, 0x27, 0xbe, 0xa9, 
  0xf8, 0x16, 0x8e, 0x6c, 0x01, 0x26, 0xfe, 0x2c, 0x01, 0x26, 0xfe, 0x48, 0xf8, 0xe8, 0xbf, 0x74, 
  0xf9, 0x16, 0x3e, 0x62, 0xe7, 0xde, 0xd5, 0x5c, 0x13, 0x29, 0xbe, 0xa0, 0x12, 0x29, 0xbe, 0x48, 
  0x00, 0x2e, 0xfe, 0xa0, 0x13, 0x15, 0xbe, 0xa0, 0x12, 0x17, 0xbe, 0xa0, 0xf0, 0xec, 0xfd, 0x5c, 
  0x0a, 0x2b, 0xbe, 0xa0, 0x0a, 0x2d, 0xbe, 0xa0, 0x12, 0x27, 0x3e, 0x85, 0x01, 0x40, 0xf2, 0xa0, 
  0x00, 0x42, 0xf2, 0xa0, 0x01, 0x42, 0xce, 0xa0, 0x00, 0x40, 0xce, 0xa0, 0x00, 0xf8, 0xff, 0xa0, 
  0x00, 0xfa, 0xff, 0xa0, 0xfd, 0xf0, 0xbf, 0xa0, 0xfe, 0xf2, 0xbf, 0xa0, 0xf1, 0x05, 0xbe, 0xa0, 
  0x00, 0x05, 0xbe, 0x80, 0x01, 0x1f, 0xbe, 0xa0, 0x01, 0x4e, 0xfe, 0xa0, 0xb9, 0x96, 0xfd, 0x5c, 
  0x05, 0x3f, 0xbe, 0x04, 0x51, 0x0c, 0x7e, 0xe8, 0x00, 0x3a, 0xfe, 0xa0, 0x00, 0x38, 0xfe, 0xa0, 
  0x05, 0x0c, 0xfe, 0xa0, 0x54, 0x0e, 0x7e, 0xe8, 0x90, 0x0f, 0xfe, 0xa0, 0x00, 0x3c, 0xfe, 0xa0, 
  0xf0, 0x15, 0xbe, 0x08, 0x01, 0x14, 0x7e, 0x62, 0x15, 0x00, 0x54, 0x5c, 0x0f, 0x36, 0xfe, 0xa0, 
  0x04, 0x1a, 0x7e, 0x62, 0x61, 0x00, 0x68, 0x5c, 0x61, 0x1e, 0xfe, 0xe4, 0x01, 0x1f, 0xbe, 0xa0, 
  0x01, 0x1c, 0xfe, 0x86, 0x10, 0x00, 0x68, 0x5c, 0x0e, 0x15, 0xbe, 0xa0, 0x04, 0x14, 0xfe, 0x28, 
  0x0a, 0x37, 0xbe, 0x4c, 0x02, 0x1a, 0x7e, 0x62, 0x68, 0x00, 0x68, 0x5c, 0xff, 0x2a, 0x3e, 0x87, 
  0xff, 0x2c, 0x3a, 0x87, 0xff, 0x2a, 0xba, 0x80, 0xff, 0x2c, 0xba, 0x80, 0x6d, 0x00, 0x7c, 0x5c, 
  0x14, 0x15, 0xbe, 0xa0, 0x17, 0x15, 0xbe, 0x84, 0x03, 0x14, 0xfe, 0x28, 0x19, 0x15, 0xbe, 0x48, 
  0x0a, 0x37, 0xbe, 0x4c, 0x17, 0x15, 0xbe, 0xa0, 0x02, 0x14, 0xfe, 0x28, 0x01, 0x34, 0xfe, 0x80, 
  0x1a, 0x15, 0xbe, 0x48, 0x01, 0x34, 0xfe, 0x84, 0x0a, 0x37, 0xbe, 0x4c, 0x18, 0x37, 0xbe, 0x4c, 
  0x02, 0x36, 0xfe, 0x48, 0xf2, 0xf5, 0x3d, 0x61, 0x01, 0x20, 0xfe, 0x34, 0x03, 0x20, 0x7e, 0x61, 
  0x01, 0x38, 0xf2, 0x80, 0x13, 0x2b, 0xb2, 0xe2, 0x20, 0x3d, 0xb2, 0x80, 0x20, 0x2f, 0xb2, 0x80, 
  0x00, 0xf0, 0xe3, 0xa0, 0xf2, 0xf7, 0x3d, 0x61, 0x01, 0x22, 0xfe, 0x34, 0x03, 0x22, 0x7e, 0x61, 
  0x01, 0x3a, 0xf2, 0x80, 0x12, 0x2d, 0xb2, 0xe2, 0x21, 0x3d, 0xb2, 0x80, 0x21, 0x2f, 0xb2, 0x80, 
  0x00, 0xf2, 0xe3, 0xa0, 0x14, 0x2f, 0xbe, 0x4c, 0x22, 0x47, 0xbe, 0xa0, 0x22, 0x49, 0xbe, 0xa0, 
  0x16, 0x2b, 0x3e, 0x87, 0x96, 0x00, 0x68, 0x5c, 0x91, 0x00, 0x4c, 0x5c, 0x16, 0x15, 0xbe, 0xa0, 
  0x12, 0x15, 0xbe, 0x84, 0x13, 0x25, 0x3e, 0x87, 0x0a, 0x2b, 0x06, 0x85, 0x00, 0x46, 0xfa, 0xa0, 
  0x96, 0x00, 0x7c, 0x5c, 0x15, 0x15, 0xbe, 0xa0, 0x13, 0x15, 0xbe, 0x84, 0x12, 0x27, 0x3e, 0x87, 
  0x0a, 0x2d, 0x06, 0x85, 0x00, 0x48, 0xfa, 0xa0, 0xcc, 0xcc, 0xfd, 0x5c, 0x16, 0x2b, 0x3e, 0x6a, 
  0x10, 0x00, 0x68, 0x5c, 0x00, 0x05, 0xbe, 0xf8, 0x23, 0xf9, 0xbf, 0xa4, 0x24, 0xfb, 0xbf, 0xa4, 
  0x4d, 0x0e, 0xfe, 0xe4, 0x1e, 0x35, 0xbe, 0xa0, 0x1b, 0x35, 0x3e, 0x87, 0x1a, 0x15, 0xbe, 0xa0, 
  0x04, 0x14, 0xfe, 0x2c, 0x00, 0x15, 0xfe, 0x48, 0x0a, 0x45, 0x96, 0x94, 0x00, 0x44, 0xfe, 0x40, 
  0x00, 0x45, 0xbe, 0x44, 0x4d, 0x0c, 0xfe, 0xe4, 0x05, 0x17, 0xbe, 0x04, 0x1f, 0x17, 0xbe, 0x86, 
  0x00, 0x4c, 0xd6, 0xa0, 0x01, 0x4c, 0xea, 0x80, 0xff, 0x4c, 0xea, 0x4c, 0x0b, 0x3f, 0xbe, 0x80, 
  0x03, 0x16, 0xfe, 0x4c, 0x0b, 0x09, 0xbe, 0x80, 0x01, 0x16, 0xfe, 0x29, 0x01, 0x4a, 0xfe, 0x31, 
  0x01, 0x08, 0xf2, 0x84, 0x01, 0x16, 0xfe, 0x29, 0x01, 0x4a, 0xfe, 0x31, 0x02, 0x08, 0xf2, 0x84, 
  0x01, 0x4e, 0xfe, 0xa0, 0xb9, 0x96, 0xfd, 0x5c, 0x4d, 0x00, 0x7c, 0x5c, 0xe7, 0xde, 0xfd, 0x5c, 
  0x00, 0x4e, 0xfe, 0xa0, 0xf8, 0xe8, 0x3f, 0x61, 0x7f, 0x3a, 0xfe, 0x4c, 0x1d, 0x17, 0xbe, 0xb4, 
  0x18, 0x16, 0xfe, 0x2c, 0x0b, 0x4f, 0xbe, 0x68, 0xf7, 0xe8, 0x3f, 0x61, 0x7f, 0x38, 0xfe, 0x4c, 
  0x1c, 0x17, 0xbe, 0xb4, 0x18, 0x16, 0xfe, 0x2c, 0x08, 0x16, 0xfe, 0x28, 0x0b, 0x4f, 0xbe, 0x68, 
  0x26, 0x17, 0xbe, 0xa0, 0x08, 0x16, 0xfe, 0x2c, 0x0b, 0x4f, 0xbe, 0x68, 0x04, 0x17, 0xbe, 0xa0, 
  0x02, 0x16, 0xfe, 0x2c, 0x0b, 0x4f, 0xbe, 0x68, 0x09, 0x4f, 0x3e, 0x08, 0x00, 0x00, 0x7c, 0x5c, 
  0x09, 0x17, 0xbe, 0xa0, 0x04, 0x16, 0xfe, 0x80, 0x18, 0x15, 0xbe, 0xa0, 0x08, 0x14, 0xfe, 0x2c, 
  0x19, 0x15, 0xbe, 0x68, 0x08, 0x14, 0xfe, 0x2c, 0x1a, 0x15, 0xbe, 0x68, 0x08, 0x14, 0xfe, 0x2c, 
  0x1b, 0x15, 0xbe, 0x68, 0x0b, 0x15, 0x3e, 0x08, 0x04, 0x16, 0xfe, 0x80, 0x13, 0x15, 0xbe, 0xa0, 
  0x10, 0x14, 0xfe, 0x2c, 0x12, 0x15, 0xbe, 0x68, 0x0b, 0x15, 0x3e, 0x08, 0x04, 0x16, 0xfe, 0x80, 
  0x15, 0x15, 0xbe, 0xa0, 0x0b, 0x15, 0x3e, 0x08, 0x04, 0x16, 0xfe, 0x80, 0x16, 0x15, 0xbe, 0xa0, 
  0x0b, 0x15, 0x3e, 0x08, 0x04, 0x16, 0xfe, 0x80, 0x17, 0x15, 0xbe, 0xa0, 0x10, 0x14, 0xfe, 0x2c, 
  0x14, 0x15, 0xbe, 0x68, 0x0b, 0x15, 0x3e, 0x08, 0x00, 0x00, 0x7c, 0x5c, 0x01, 0x4a, 0xfe, 0xa4, 
  0x30, 0x08, 0xfe, 0xa0, 0x00, 0x4c, 0xfe, 0xa0, 0x00, 0x3a, 0xfe, 0xa0, 0x00, 0x38, 0xfe, 0xa0, 
  0x00, 0x34, 0xfe, 0xa0, 0x00, 0x0c, 0xfe, 0xa0, 0x00, 0x0e, 0xfe, 0xa0, 0x00, 0x00, 0x7c, 0x5c, 
  0x10, 0x16, 0xfe, 0x2c, 0x10, 0x18, 0xfe, 0xa0, 0x01, 0x14, 0xfe, 0x29, 0x0b, 0x15, 0xb2, 0x81, 
  0x01, 0x14, 0xfe, 0x31, 0xf3, 0x18, 0xfe, 0xe4, 0x00, 0x00, 0x7c, 0x5c, 0x00, 0x00, 0x02, 0x00, 
  0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 
  0x00, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x10, 0x12, 0x00, 0x00, 0x10, 0xff, 0xff, 0x00, 0x00, 
  0xa0, 0x0f, 0x00, 0x00, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0xbb, 0x03, 0x99, 0x00, 0xdd, 0x01, 0xee, 0x00, 0x1e, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 
  0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
};
// =======[ Public Spin methods... ]===============================================
//
// -------[ Start and stop methods... ]--------------------------------------------
//
// Start and stop methods are used for starting individual cogs or stopping all
// of them at once.
int32_t S2_start_motors(S2 *self)
{
  int32_t result = 0;
  /*  This method starts the motor control cog. It must be called before any
       of the drawing and motor control methods are used. 
    ''
    '' `Example: s2.start_motors
    ''
    ''     Start the motor controller.
    
   */
  if (!(((uint8_t *)&dat[1185])[0])) {
    ((uint16_t *)&dat[1088])[0] = -1;
    ((int32_t *)&dat[1044])[0] = (int32_t)(&(*(uint16_t *)&dat[1136])) + (CNT_IDLER << 1);
    result = -((((uint8_t *)&dat[1185])[0] = cognew((int32_t)(&(*(int32_t *)&dat[0])), (int32_t)(&(*(uint16_t *)&dat[1088]))) + 1) > 0);
    while ((*(uint16_t *)&dat[1088])) {
      Yield__();
    }
    ((uint8_t *)&dat[1184])[0] = 0;
    S2_here_is(self, 0, 0);
    S2_heading_is(self, (*(uint16_t *)&dat[1078]));
    S2_set_speed(self, 7);
  }
  return result;
}

int32_t S2_begin_path(S2 *self)
{
  /*  Begin a path of connected movements. This method should be called before starting
       any sequence of drawing movements that need to segue smoothly, one to the next.
       The path should end with a call to `end_path.
    ''
    '' `Example: s2.begin_path
    ''
    ''     Begin a new block of connected movements.
    
   */
  if (!(((uint8_t *)&dat[1184])[0])) {
    ((uint8_t *)&dat[1184])[0] = 1;
  }
  return 0;
}

int32_t S2_end_path(S2 *self)
{
  /*  Output the last movement in the path, if there is one, and end the path.
       `Note: Omitting this statement may cause the last path segment not to be drawn.
    ''
    '' `Example: s2.end_path
    ''
    ''     End the current path and draw the last segment.
    
   */
  if (((uint8_t *)&dat[1184])[0] == 2) {
    S2_run_motors(self, 0, (*(int32_t *)&dat[1124]), (*(int32_t *)&dat[1120]), (*(int32_t *)&dat[1128]), (*(int32_t *)&dat[1132]), 0);
  }
  ((uint8_t *)&dat[1184])[0] = 0;
  return 0;
}

int32_t S2_set_speed(S2 *self, int32_t spd)
{
  /*  Set the speed for the drawing methods, along with the "go_", "turn_",
       and "arc_" motion methods.
    ''
    ''     `spd (0 - 15): The top speed used in subsequent calls to these methods.
    ''
    '' `Example: set_speed(7)
    ''
    ''     Set the speed to half of maximum velocity.
    
   */
  ((uint8_t *)&dat[1186])[0] = spd;
  return 0;
}

int32_t S2_move_to(S2 *self, int32_t x, int32_t y)
{
  /*  Move directly to the point (x, y). Units are approximately 0.5mm.
    ''
    ''     `x and `y (-32000 - 32000):  Target coordinates of the move.
    ''
    '' `Example: s2.move_to(1000, 50)
    ''
    ''     Move to a point 500 mm to the right and 25mm above the origin.
    
   */
  S2_move_by(self, (x - (*(int32_t *)&dat[1056])), (y - (*(int32_t *)&dat[1060])));
  return 0;
}

int32_t S2_arc_to(S2 *self, int32_t x, int32_t y, int32_t radius)
{
  /*  Move to a chosen point via an arc of a specified radius. Units are approximately 0.5mm.
    ''
    ''     `x and `y (-32000 - 32000): Target coordinates of move.
    ''
    ''     `radius: Radius of turn. (Positive is counterclockwise; negative is clockwise).
    ''
       The Cartesian distance from the current location to the target position must be no more than
       2 * `radius. If it's greater than that, the robot will move in a straight line toward the target
       position first to make up the difference, then perform the arc.
    ''
    '' `Example: s2.arc_to(1000, 50, -100)
    ''
    ''     Move to the point 500 mm to the right and 25mm above the origin in a clockwise arc of radius 25mm.
    
   */
  S2_arc_by(self, (x - (*(int32_t *)&dat[1056])), (y - (*(int32_t *)&dat[1060])), radius);
  return 0;
}

int32_t S2_move_by(S2 *self, int32_t dx, int32_t dy)
{
  int32_t	angle;
  /*  Move from the current location by a specified displacement. Units are approximately 0.5mm.
    ''
    ''     `dx and `dy (-32000 - 32000):  Displacement of the target position from the current position.
    ''  
    '' `Example: s2.move_by(100, 50)
    ''
    ''     Move to a point 50 mm to the right and 25mm above the current location.
    
   */
  S2_turn_to(self, (angle = S2__atan2(self, dy, dx)));
  S2_go_forward(self, (Sqrt__(((dx * dx) + (dy * dy)))));
  S2_here_is(self, ((*(int32_t *)&dat[1056]) + dx), ((*(int32_t *)&dat[1060]) + dy));
  return 0;
}

int32_t S2_arc_by(S2 *self, int32_t dx, int32_t dy, int32_t radius)
{
  int32_t	dist2, dist, diam, half_angle, tilt;
  /*  Move from the current location by a specified displacement via an arc of a specified radius.
       Units are approximately 0.5mm
    ''
    ''     `x and `y (-32000 - 32000): Target coordinates of move.
    ''
    ''     `radius: Radius of turn. (Positive is counterclockwise; negative is clockwise).
    ''
       The Cartesian length of the displacement must be no more than
       2 * radius. If it's greater than that, the robot will move in a straight line to the target
       position first to make up the difference, then perform the arc. Units are approximately 0.5mm.
    ''
    '' `Example: s2.arc_by(50, 50, -100)
    ''
    ''     Move to the point 25 mm to the right of and 25mm above the current location in a clockwise arc of radius 50mm.
    
   */
  dist2 = (dx * dx) + (dy * dy);
  dist = Sqrt__(dist2);
  tilt = S2__atan2(self, dy, dx);
  diam = (abs(radius)) << 1;
  if (dist > diam) {
    S2_turn_to(self, tilt);
    S2_go_forward(self, (dist - diam));
    dist = diam;
    dist2 = dist * dist;
  }
  half_angle = S2__atan2(self, (Shr__(dist, 1)), (Sqrt__(((radius * radius) - (Shr__(dist2, 2))))));
  if (radius < 0) {
    half_angle = -half_angle;
  }
  S2_turn_to(self, (tilt - half_angle));
  S2_arc(self, (half_angle << 1), radius);
  S2_here_is(self, ((*(int32_t *)&dat[1056]) + dx), ((*(int32_t *)&dat[1060]) + dy));
  S2_heading_is(self, (tilt + half_angle));
  return 0;
}

int32_t S2_align_with(S2 *self, int32_t heading)
{
  int32_t	dw;
  int32_t result = 0;
  /*  Turn so that the robot is pointed parallel to the desired heading (S2 angle units),
       either in the selected direction (returns 1) or opposite the selected direction
       (returns -1), whichever requires the shortest turn to achieve.
    ''
    ''     `heading: Direction to align with in S2 angle units.
    ''
    '' `Example: dir := s2.align_with(150)
    ''
    ''     Point the robot to angle 150 (S2 angle units) or opposite that angle. Set dir to ±1, accordingly.
    
   */
  dw = (heading - (*(int32_t *)&dat[1064])) % (*(uint16_t *)&dat[1072]);
  dw = dw + ((*(uint16_t *)&dat[1072]) & -(dw < 0));
  if (dw > ((uint16_t *)&dat[1076])[0]) {
    dw = dw - (*(uint16_t *)&dat[1072]);
  }
  if ((abs(dw)) <= ((uint16_t *)&dat[1078])[0]) {
    result = 1;
  } else {
    dw = (dw - (*(uint16_t *)&dat[1076])) + ((*(uint16_t *)&dat[1072]) & -(dw < 0));
    result = -1;
  }
  S2_turn(self, dw);
  S2_heading_is(self, ((*(int32_t *)&dat[1064]) + dw));
  return result;
}

int32_t S2_turn_to_deg(S2 *self, int32_t heading)
{
  /*  Turn the robot to the desired heading (degrees).
    ''
    ''     `heading: Direction to point in degrees north of east.
    ''
    '' `Example: s2.turn_to(135)
    ''
    ''     Point the robot to an angle of 135 degrees (i.e. northwest).
    
   */
  S2_turn_to(self, ((heading * (*(uint16_t *)&dat[1072])) / 360));
  return 0;
}

int32_t S2_turn_to(S2 *self, int32_t heading)
{
  /*  Turn the robot to the desired heading (S2 angle units).
    ''
    ''     `heading: Direction to point in S2 angle units north of east.
    ''
    '' `Example: s2.turn_to(500)
    ''
    ''     Point the robot to an angle of 500 S2 angle units.
    
   */
  S2_turn_by(self, (heading - (*(int32_t *)&dat[1064])));
  return 0;
}

int32_t S2_turn_by_deg(S2 *self, int32_t dw)
{
  /*  Turn the robot by the desired amount (degrees).
    ''
    ''     `dw: angle by which to turn, in degrees. (Positive is counterclockwise; negative is clockwise.)
    ''
       If the net turn angle is greater than 180 degrees, the shorter rotation
       in the opposite direction is used instead.
    ''
    '' `Example: s2.turn_by_deg(90)
    ''
    ''     Rotate the robot by an angle of 90 degrees CCW.
    
   */
  S2_turn_by(self, ((dw * (*(uint16_t *)&dat[1072])) / 360));
  return 0;
}

int32_t S2_turn_by(S2 *self, int32_t dw)
{
  /*  Turn the robot by the desired amount (degrees).
    ''
    ''     `dw: angle by which to turn, in S2 angle units. (Positive is counterclockwise; negative is clockwise.)
    ''
       If the net turn angle is greater than 180 degrees, the shorter rotation
       in the opposite direction is used instead.
    ''
    '' `Example: s2.turn_by(500)
    ''
    ''     Rotate the robot by an angle of 500 S2 angle units CCW.
    
   */
  dw = dw % (*(uint16_t *)&dat[1072]);
  dw = dw + ((*(uint16_t *)&dat[1072]) & -(dw < 0));
  if (dw > ((uint16_t *)&dat[1076])[0]) {
    dw = dw - (*(uint16_t *)&dat[1072]);
  }
  S2_turn(self, dw);
  S2_heading_is(self, ((*(int32_t *)&dat[1064]) + dw));
  return 1;
}

int32_t S2_here_is(S2 *self, int32_t x, int32_t y)
{
  /*  Reset the current position. Units are approximately 0.5mm.
    ''
    ''     `x and `y (-32000 - 32000): New coordinates of current position.
    ''
    '' `Example: s2.here_is(0, 0)
    ''
    ''     Reset the origin to the current location.
    
   */
  ((int32_t *)&dat[1056])[0] = x;
  ((int32_t *)&dat[1060])[0] = y;
  return 0;
}

int32_t S2_heading_is_deg(S2 *self, int32_t w)
{
  /*  Reset the current heading. Units are in degrees north of east.
    ''
    ''     `w: New value for current heading.
    ''
    '' `Example: s2.heading_is_deg(90)
    ''
    ''     Reset the current heading to 90 degrees.
    
   */
  S2_heading_is(self, ((w * (*(uint16_t *)&dat[1072])) / 360));
  return 0;
}

int32_t S2_heading_is(S2 *self, int32_t w)
{
  /*  Reset the current heading.  Units are in S2 angle units north of east.
    ''
    ''     `w: New value for current heading.
    ''
    '' `Example: s2.heading_is(567)
    ''
    ''     Reset the current heading to 567.
    
   */
  ((int32_t *)&dat[1064])[0] = w % (*(uint16_t *)&dat[1072]);
  ((int32_t *)&dat[1064])[0] = (*(int32_t *)&dat[1064]) + ((*(uint16_t *)&dat[1072]) & -((*(int32_t *)&dat[1064]) < 0));
  return 0;
}

/* 
---------[ Motion methods... ]-------------------------------------------------

   Motion methods control the movement of the S2 robot. MOTION METHODS DO NOT
   KEEP TRACK OF THE S2'S POSITION AND HEADING, unless called from one of the
   drawing methods. As such, they should NOT be mixed with calls to drawing
   methods.
   ''
   There are two basic families of motion methods: the regular kind which perform
   the commanded movements in sequence, and the "now" methods (indicated by a
   trailing `_now in the method name), which preempt any movements in progress.
   The "now" methods should be used for movements which have to react to sensor
   inputs, such as those found in line-following of obstacle-avoidance programs.
 */
int32_t S2_read_wheel_calibration(S2 *self)
{
  int32_t _local__0000[2];
  /*  Read wheel calibration values from EEPROM, and use them if they're reasonable.
       Returns a packed long containing the calibration values. (See `get_wheel_calibration.)
       If no valid values exist in EEPROM, sets (and returns) the default values.
    ''
    '' `Example: s2.read__wheel_calibration
    ''
    ''     Get previously-written wheel calibration values.
    
   */
  if (S2__ee_rdblock(self, (int32_t)(&_local__0000[0]), EE_WHEEL_CALIB, 4)) {
    _local__0000[1] = Shr__(_local__0000[0], 16);
    _local__0000[0] = _local__0000[0] & 0xffff;
    if ((((_local__0000[0] > 900) && (_local__0000[0] < 1000)) && (_local__0000[1] > 100)) && (_local__0000[1] < 200)) {
      return S2_set_wheel_calibration(self, _local__0000[0], _local__0000[1]);
    }
  }
  return S2_default_wheel_calibration(self);
}

int32_t S2_write_wheel_calibration(S2 *self)
{
  /*  Write current wheel calibration values to EEPROM.
       Returns true on success, false on failure.
    ''
    '' `Example: s2.write_wheel_calibration
    ''
    ''     Write Full_circle and Wheel_space to EEPROM.
    
   */
  return S2__ee_wrblock(self, (int32_t)(&(*(uint16_t *)&dat[1072])), EE_WHEEL_CALIB, 4);
}

int32_t S2_default_wheel_calibration(S2 *self)
{
  /*  Restore wheel calibration to default values. DOES NOT SAVE IN EEPROM.
       This method is optional unless read_calibration or set_calibration
       have been called.
    ''
    '' `Example: s2.default_calibration
    ''
    ''     Restore calibration defaults.
    
   */
  return S2_set_wheel_calibration(self, DEFAULT_FULL_CIRCLE, DEFAULT_WHEEL_SPACE);
}

int32_t S2_set_wheel_calibration(S2 *self, int32_t circle, int32_t space)
{
  /*  Set the wheel calibration values to method's arguments, if they're reasonable.
       IT DOES NOT SAVE THEM IN EEPROM.
    ''
    ''     `circle: The number of encoder pulses required to turn in place 360 degrees.
    ''
    ''     `space: The spacing between the wheels. (Units are approximately 1mm.)
    ''
    '' `Example: s2.set_wheel_calibration(960, 160)
    ''
    ''     Set `Full_circle to 960 and `Wheel_space to 160.
    
   */
  ((uint16_t *)&dat[1072])[0] = circle;
  ((uint16_t *)&dat[1074])[0] = space;
  S2__compute_calibration(self);
  return S2_get_wheel_calibration(self);
}

int32_t S2_get_wheel_calibration(S2 *self)
{
  /*  Return the current calibration values in the following format:
    ''
    '''  31                         16 15                          0
    ''' ┌─────────────────────────────┬────────────────────────────┐    
    ''' │         Full_circle         │         Wheel_space        │
    ''' └─────────────────────────────┴────────────────────────────┘
    ''
    '' `Example: one_rotation := s2.get_wheel_calibration >> 16
    ''
    ''     Assign the value of `Full_circle to `one_rotation.
    
   */
  return (((*(uint16_t *)&dat[1072]) << 16) | (*(uint16_t *)&dat[1074]));
}

int32_t S2_go_left(S2 *self, int32_t dist)
{
  /*  Turn left and go forward from there by the indicated distance. Units are
       approximately 0.5mm.
    ''
    ''     `dist: Distance to move after turning left.
    ''
    '' `Example: s2.go_left(500)
    ''
    ''     Turn left and move forward 250mm.
    
   */
  S2_turn_deg(self, 90);
  S2_go_forward(self, dist);
  return 0;
}

int32_t S2_go_right(S2 *self, int32_t dist)
{
  /*  Turn right and go forward from there by the indicated distance. Units are
       approximately 0.5mm.
    ''
    ''     `dist: Distance to move after turning right.
    ''
    '' `Example: s2.go_right(500)
    ''
    ''     Turn right and move forward 250mm.
    
   */
  S2_turn_deg(self, (-90));
  S2_go_forward(self, dist);
  return 0;
}

int32_t S2_go_forward(S2 *self, int32_t dist)
{
  /*  Go forward by the indicated distance. Units are approximately 0.5mm.
    ''
    ''     `dist: Distance to move forward.
    ''
    '' `Example: s2.go_forward(500)
    ''
    ''     Move forward 250mm.
    
   */
  if ((abs(dist)) == FOREVER) {
    S2_move(self, 100, 100, 0, (*(uint8_t *)&dat[1186]), 1);
  } else {
    S2_move(self, dist, dist, 0, (*(uint8_t *)&dat[1186]), 0);
  }
  return 0;
}

int32_t S2_go_back(S2 *self, int32_t dist)
{
  /*  Go backward by the indicated distance. Units are approximately 0.5mm.
    ''
    ''     `dist: Distance to move backward.
    ''
    '' `Example: s2.go_back(500)
    ''
    ''     Move backward 250mm.
    
   */
  if ((abs(dist)) == FOREVER) {
    S2_move(self, (-100), (-100), 0, (*(uint8_t *)&dat[1186]), 1);
  } else {
    S2_move(self, (-dist), (-dist), 0, (*(uint8_t *)&dat[1186]), 0);
  }
  return 0;
}

int32_t S2_turn_deg(S2 *self, int32_t ccw_degrees)
{
  /*  Turn in place counter-clockwise by the indicated number of degrees.
       Negative values will turn clockwise.
    ''
    ''     `ccw_degrees: Number of counterclockwise degrees to turn.
    ''
    '' `Example: s2.turn_deg(-90)
    ''
    ''     Turn right.
    
   */
  S2_arc_deg(self, ccw_degrees, 0);
  return 0;
}

int32_t S2_arc_deg(S2 *self, int32_t ccw_degrees, int32_t radius)
{
  int32_t	r, l;
  /*  Move in a counter-clockwise arc of the indicated radius by the specified
       number of degrees. Radius units are approximately 0.5mm. Negative angles
       result in a clockwise arc.
    ''
    ''     `ccw_degrees: Number of counterclockwise degrees by which to arc.
    ''
    ''     `radius: Radius of arc.
    ''
    '' `Example: s2.arc_deg(90, 500)
    ''
    ''     Make a sweeping left turn with a radius of 250mm.
    
   */
  S2_arc(self, (((*(uint16_t *)&dat[1072]) * ccw_degrees) / 360), radius);
  return 0;
}

int32_t S2_turn(S2 *self, int32_t ccw_units)
{
  /*  Turn in place counter-clockwise by the indicated number of degrees.
       Negative values will turn clockwise.
    ''
    ''     `ccw_units: Number of S2 angle units by which to turn in place.
    ''
    '' `Example: s2.turn(-50)
    ''
    ''     Turn a bit to the right by 50 S2 angle units.
    
   */
  S2_arc(self, ccw_units, 0);
  return 0;
}

int32_t S2_arc(S2 *self, int32_t ccw_units, int32_t radius)
{
  int32_t	r, l;
  /*  Move in a counter-clockwise arc of the indicated radius by the specified
       number of S2 angle units. Radius units are approximately 0.5mm. Negative angles
       result in a clockwise arc.
    ''
    ''     `ccw_units: Number of counterclockwise S2 angle units by which to arc.
    ''
    ''     `radius: Radius of arc.    ''
    ''
    '' `Example: s2.arc(100, 50)
    ''
    ''     Arc a bit to the left by 100 S2 angle units with a 25mm radius.
    
   */
  r = (ccw_units * (radius + (*(uint16_t *)&dat[1074]))) / (*(uint16_t *)&dat[1074]);
  l = (ccw_units * (radius - (*(uint16_t *)&dat[1074]))) / (*(uint16_t *)&dat[1074]);
  S2_move(self, l, r, 0, (*(uint8_t *)&dat[1186]), 0);
  return 0;
}

int32_t S2_turn_deg_now(S2 *self, int32_t ccw_degrees)
{
  /*  Turn in place counter-clockwise by the indicated number of degrees.
       Negative values will turn clockwise.
       This is a `_now method, which preempts any current motion in progress.
    ''
    ''     `ccw_degrees: Number of counterclockwise degrees to turn.
    ''
    '' `Example: s2.turn_deg_now(-90)
    ''
    ''     Immediate turn right.
    
   */
  S2_arc_deg_now(self, ccw_degrees, 0);
  return 0;
}

int32_t S2_arc_deg_now(S2 *self, int32_t ccw_degrees, int32_t radius)
{
  int32_t	r, l;
  /*  Move in a counter-clockwise arc of the indicated radius by the specified
       number of degrees, preempting any motion in progress.
       Radius units are approximately 0.5mm. Negative angles
       result in a clockwise arc.
    ''
    ''     `ccw_degrees: Number of counterclockwise degrees by which to arc.
    ''
    ''     `radius: Radius of arc.
    ''
    '' `Example: s2.arc_deg_now(90, 500)
    ''
    ''     Make an immediate sweeping left turn with a radius of 250mm.
    
   */
  S2_arc_now(self, (((*(uint16_t *)&dat[1072]) * ccw_degrees) / 360), radius);
  return 0;
}

int32_t S2_turn_now(S2 *self, int32_t ccw_units)
{
  /*  Turn in place counter-clockwise by the indicated number of degrees,
       preempting any motion in porgress. Negative values will turn clockwise.
    ''
    ''     `ccw_units: Number of S2 angle units by which to turn in place.
    ''
    '' `Example: s2.turn_now(-50)
    ''
    ''     Immediately turn a bit to the right by 50 S2 angle units.
    
   */
  S2_arc_now(self, ccw_units, 0);
  return 0;
}

int32_t S2_arc_now(S2 *self, int32_t ccw_units, int32_t radius)
{
  int32_t	r, l;
  /*  Move in a counter-clockwise arc of the indicated radius by the specified
       number of S2 angle units, preempting any motion in progress.
       Radius units are approximately 0.5mm. Negative angles result in a clockwise arc.
    ''
    ''     `ccw_units: Number of counterclockwise S2 angle units by which to arc.
    ''
    ''     `radius: Radius of arc.    ''
    ''
    '' `Example: s2.arc_now(100, 50)
    ''
    ''     Immediately arc a bit to the left by 100 S2 angle units with a 25mm radius.
    
   */
  r = (ccw_units * (radius + (*(uint16_t *)&dat[1074]))) / (*(uint16_t *)&dat[1074]);
  l = (ccw_units * (radius - (*(uint16_t *)&dat[1074]))) / (*(uint16_t *)&dat[1074]);
  S2_move_now(self, l, r, 0, (*(uint8_t *)&dat[1186]), 0);
  return 0;
}

int32_t S2_move(S2 *self, int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop)
{
  int32_t	max_d, max_pd, max_rvel, max_lvel, end_spd;
  int32_t result = 0;
  /*  This is the base-level non-reactive user move routine. It does not interrupt motion in progress.
       If called during path construction, velocities will blend. If no path, velocity ramps to zero at end.
       This method may not return right away if it has to wait for current motion to complete.
    ''  
    ''     `left_distance: Amount to move left wheel (-32767 - 32767) in 0.5mm (approx.) increments.
    ''
    ''     `right_distance: Amount to move right wheel (-32767 - 32767) in 0.5mm (approx.) increments.
    ''
    ''     `move_time: If non-zero, time (ms) after which to stop, regardless of distance traveled.
    ''
    ''     `max_speed (0 - 15): Maximum speed (after ramping).
    ''
    ''     `no_stop: If non-zero, keep running, regardless of distance traveled unless/until timeout or a preemptive change.
    ''
    '' `Example: s2.move(10000, 5000, 10000, 7, 0)
    ''
    ''     Move in a clockwise arc for 10000/2 mm on outside, or until 10 seconds elapse, whichever occurs first, at half speed.
    
   */
  left_distance = Min__((Max__((-32767), left_distance)), 32767);
  right_distance = Min__((Max__((-32767), right_distance)), 32767);
  max_speed = Min__((Max__(0, max_speed)), 15);
  ((uint8_t *)&dat[1186])[0] = max_speed;
  if (((uint8_t *)&dat[1184])[0] == 2) {
    if (((left_distance ^ (*(int32_t *)&dat[1124])) & 0x8000) || ((right_distance ^ (*(int32_t *)&dat[1120])) & 0x8000)) {
      end_spd = 0;
    } else {
      max_d = Max__((abs(left_distance)), (abs(right_distance)));
      max_pd = Max__((abs((*(int32_t *)&dat[1124]))), (abs((*(int32_t *)&dat[1120]))));
      /* 
              
       */
      max_rvel = ((Min__(((((abs(right_distance)) * max_speed) + (Shr__(max_d, 1))) / max_d), ((((abs((*(int32_t *)&dat[1120]))) * (*(int32_t *)&dat[1132])) + (Shr__(max_pd, 1))) / max_pd))) * max_d) / (Max__((abs(right_distance)), 1));
      /* 
              
       */
      max_lvel = ((Min__(((((abs(left_distance)) * max_speed) + (Shr__(max_d, 1))) / max_d), ((((abs((*(int32_t *)&dat[1124]))) * (*(int32_t *)&dat[1132])) + (Shr__(max_pd, 1))) / max_pd))) * max_d) / (Max__((abs(left_distance)), 1));
      end_spd = Min__(max_rvel, max_lvel);
    }
    S2_run_motors(self, 0, (*(int32_t *)&dat[1124]), (*(int32_t *)&dat[1120]), (*(int32_t *)&dat[1128]), (*(int32_t *)&dat[1132]), end_spd);
    result = end_spd;
  }
  if (((uint8_t *)&dat[1184])[0] >= 1) {
    if ((no_stop) && (move_time == 0)) {
      S2_run_motors(self, MOT_CONT, left_distance, right_distance, move_time, max_speed, 0);
      ((uint8_t *)&dat[1184])[0] = 0;
    } else {
      ((int32_t *)&dat[1124])[0] = left_distance;
      ((int32_t *)&dat[1120])[0] = right_distance;
      ((int32_t *)&dat[1128])[0] = move_time;
      ((int32_t *)&dat[1132])[0] = max_speed;
      ((uint8_t *)&dat[1184])[0] = 2;
    }
  } else {
    S2_run_motors(self, (MOT_CONT & -(no_stop != 0)), left_distance, right_distance, move_time, max_speed, 0);
  }
  return result;
}

int32_t S2_wheels_now(S2 *self, int32_t left_velocity, int32_t right_velocity, int32_t move_time)
{
  /*  Set the wheel speeds preemptively. This method interrupts the movement in progress and
       deletes all path information. IT method always returns immediately.
    ''
    ''     `left_velocity and `right_velocity (-255 to 255): Left and right wheel velocities, respectively.
    ''
    ''     `move_time: If > 0, time out after move_time ms; otherwise do not time out.
    ''
    '' `Example: s2.wheels_now(-255, 255, 5000)
    ''
    ''     Turn left, in place, at maximum speed, for five seconds.
    
   */
  S2_move_now(self, left_velocity, right_velocity, move_time, (Shr__((Min__((Max__((abs(left_velocity)), (abs(right_velocity)))), 255)), 4)), 1);
  return 0;
}

int32_t S2_move_now(S2 *self, int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop)
{
  /*  This is the base-level preemptive user routine for reactive movements (e.g. for line following).
       It interrupts any movement in progress and deletes all path information.
       This method always returns immediately. 
    ''
    ''     `left_distance: Amount to move left wheel (-32767 - 32767) in 0.5mm (approx.) increments.
    ''
    ''     `right_distance: Amount to move right wheel (-32767 - 32767) in 0.5mm (approx.) increments.
    ''
    ''     `move_time: If non-zero, time (ms) after which to stop, regardless of distance traveled.
    ''
    ''     `max_speed (0 - 15): Maximum speed (after ramping).
    ''
    ''     `no_stop: If non-zero, keep running, regardless of distance traveled unless/until timeout or another preemptive change.
    ''
    '' `Example: s2.move_now(1000, -1000, 0, 15, 1)
    ''
    ''     Rotate in place clockwise at full speed until preempted.
    
   */
  ((uint8_t *)&dat[1184])[0] = 0;
  S2_run_motors(self, (MOT_IMM | (MOT_CONT & -(no_stop != 0))), left_distance, right_distance, move_time, max_speed, 0);
  return 0;
}

int32_t S2_stop_now(S2 *self)
{
  /*  Stop all movement immediately and delete all path information.
    ''
    '' `Example: s2.stop_now.
    ''
    ''     Halt the S2.
    
   */
  ((uint8_t *)&dat[1184])[0] = 0;
  S2_run_motors(self, MOT_IMM, 0, 0, 0, 0, 0);
  return 0;
}

int32_t S2_wait_stop(S2 *self)
{
  /*  Wait for all current and pending motions to complete.
    ''
    '' `Example: s2.wait_stop
    ''
    ''     Wait for motions to complete, then return.
    
   */
  while (S2_moving(self)) {
    Yield__();
  }
  return 0;
}

int32_t S2_moving(S2 *self)
{
  /*  Return `true if motion is in progress or pending, `false if stopped with no pending motions.
    ''
    '' `Example: repeat while s2.moving
    ''
    ''     Continuously execute the following repeat block until motions are finished.
    
   */
  return -(((*(int32_t *)&dat[1096]) & 0x3) != 0);
}

int32_t S2_motion(S2 *self)
{
  /*  Return the current motion status as a packed long:
    ''
    ''' 31            24 23           16 15            8 7         2 1 0
    ''' ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐
    ''' │±  Left wheel  │±  Right wheel │  Idler timer  │ Idler spd │Mov│ , where
    ''' └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘
    ''
    '' Left wheel and right wheel are signed, twos complement eight bit velocity values,
    '' Idler timer is the time in 1/10 second since the last idler edge,
    '' Idler spd is an unsigned six-bit velocity value, and
    '' Mov is non-zero iff one or more motors are turning.
    '' Left and right wheel velocities are instanteous encoder counts over a 1/10-second interval.
    '' Idler wheel wheel velocity is updated every 1/10 second and represents the idler encoder count during the last 1.6 seconds.
    ''
    '' `Example: left_vel := s2.motion ~> 24
    ''
    ''     Get the current left wheel velocity as a signed 32-bit value.
    
   */
  return (*(int32_t *)&dat[1096]);
}

int32_t S2_motion_addr(S2 *self)
{
  /*  Return the address of the status and debug array.
    ''
    '' `Example: longmove(@my_stats, s2.motion_addr, 6)
    ''
    ''     Copy all status data to the local array my_stats.
    
   */
  return (int32_t)(&(*(int32_t *)&dat[1096]));
}

int32_t S2_move_ready(S2 *self)
{
  /*  Return `true if a new motion command can be accepted without waiting, `false if a command is still pending.
    ''
    '' `Example: repeat until s2.move_ready
    ''
    ''     Continuously execute the following repeat block until a new move can be accepted.
    
   */
  return -((*(uint16_t *)&dat[1088]) == 0);
}

int32_t S2_run_motors(S2 *self, int32_t command, int32_t left_distance, int32_t right_distance, int32_t timeout, int32_t max_speed, int32_t end_speed)
{
  int32_t	drop;
  /*  Base level motor activation routine. Normally, this method is not called by the user but is called by the
       many convenience methods available to the user.
    ''
    ''     `command: the OR of either or both of the following:
    ''
    ''        `MOT_IMM:   Commanded motion starts immediately, without waiting for prior motion to finish.
    ''        `MOT_CONT:  Commanded motion will continue to run at wheel ratio given by left and right distances,
    ''                     even after distances are covered.
    ''
    ''     `left_distance, `right_distance (-32767 to 32767): The distances to be covered by the left and right wheels,
    ''         respectively. Units are approximately 0.5mm.
    ''
    ''     `timeout (0 - 65535): If non-zero, time limit (ms) after which motion stops, regardless of distance covered.
    ''
    ''     `max_speed (0 - 15): Peak velocity to be reached during motion profile.
    ''
    ''     `end_speed (0 - 15): Velocity to be attained at end of motion profile. If non-zero, this is the velocity needed to
    ''         segue smoothly into the next motion profile. end_speed should never be greater than max_speed.
    ''
    '' `Example: s2.run_motors(s2#MOT_CONT, 100, -100, 5000, 8, 0)
    ''
    ''     Turn in place clockwise for 5 seconds at half speed.
    
   */
  drop = (*(uint16_t *)&dat[1090]);
  if (command & MOT_IMM) {
    ((int32_t *)(int32_t)(&(*(uint16_t *)&dat[1092])))[0] = 0;
    ((int32_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[0] = 0;
  } else {
    while (((int32_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[0]) {
      Yield__();
    }
  }
  ((uint16_t *)&dat[1092])[0] = Min__((Max__((-32767), right_distance)), 32767);
  ((uint16_t *)&dat[1094])[0] = Min__((Max__((-32767), left_distance)), 32767);
  ((int32_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[0] = (((timeout << 16) | ((Min__((Max__(0, max_speed)), 15)) << 8)) | ((Min__((Max__(0, end_speed)), 15)) << 4)) | (command & (MOT_IMM | MOT_CONT));
  if ((left_distance) || (right_distance)) {
    timeout = CNT;
    while (!((S2_moving(self)) || ((CNT - timeout) > 800000))) {
      Yield__();
    }
  }
  return 0;
}

//
//
// =======[ Private Spin methods... ]==============================================
//
// These private methods are used internally and are not accessible to the user.
//
// -------[ Miscellaneous... ]--------------------------------------------------
static int32_t S2__compute_calibration(S2 *self)
{
  /*  Compute other values dependent on Full_circle to save time in methods.  */
  ((uint16_t *)&dat[1076])[0] = Shr__((*(uint16_t *)&dat[1072]), 1);
  ((uint16_t *)&dat[1078])[0] = Shr__((*(uint16_t *)&dat[1072]), 2);
  ((int32_t *)&dat[1080])[0] = ((*(uint16_t *)&dat[1072]) * 56841) / 100000;
  return 0;
}

static int32_t S2__atan2(S2 *self, int32_t y, int32_t x)
{
  int32_t	arg, adder, n;
  int32_t result = 0;
  /*  Four-quadrant arctangent. `y and `x are signed integers.
       `Full_circle is an integer equal to the number of encoder units in a full circle.
    
   */
  if ((n = BitEncode__((Min__((abs(x)), (abs(y)))))) > 21) {
    x = x >> (n - 21);
    y = y >> (n - 21);
  }
  if ((abs(x)) > (abs(y))) {
    arg = (y << 10) / x;
    adder = (*(uint16_t *)&dat[1076]) & -(x < 0);
  } else {
    arg = ((-x) << 10) / y;
    adder = (*(uint16_t *)&dat[1078]) + ((*(uint16_t *)&dat[1076]) & -(y < 0));
  }
  result = (Shr__(((((abs(arg)) * (*(int32_t *)&dat[1080])) / (914 + (Shr__((arg * arg), 12)))) + 1), 2)) - -((abs(arg)) >= 960);
  if (arg < 0) {
    result = -result;
  }
  result = result + adder;
  result = result + ((*(uint16_t *)&dat[1072]) & -(result < 0));
  return result;
}

static int32_t S2__ee_rdblock(S2 *self, int32_t dest_addr, int32_t addr, int32_t size)
{
  int32_t	i, csum;
  /*  Read a block of data, `size bytes long, into `dest_addr, from EEPROM at `addr.
       Read one additional checksum byte, and return `true if checksum is zero;
       `false, otherwise.
    
   */
  csum = S2__ee_rdbyte(self, (addr + size));
  {
    int32_t _limit__0001 = (size - 1);
    int32_t _step__0002 = 1;
    i = 0;
    if (i >= _limit__0001) _step__0002 = -_step__0002;
    do {
      csum = csum + (((uint8_t *)dest_addr)[i] = S2__ee_rdbyte(self, (addr + i)));
      i = i + _step__0002;
    } while (((_step__0002 > 0) && (i <= _limit__0001)) || ((_step__0002 < 0) && (i >= _limit__0001)));
  }
  return -((csum & 0xff) == 0);
}

static int32_t S2__ee_wrblock(S2 *self, int32_t src_addr, int32_t addr, int32_t size)
{
  int32_t	i, data, csum;
  int32_t result = 0;
  /*  Write a block of data, `size bytes long, from `src_addr into EEPROM at `addr.
       Write one additional checksum byte at the end.
    
   */
  csum = 0;
  result = -1;
  {
    int32_t _limit__0003 = (size - 1);
    int32_t _step__0004 = 1;
    i = 0;
    if (i >= _limit__0003) _step__0004 = -_step__0004;
    do {
      data = ((uint8_t *)src_addr)[i];
      csum = csum - data;
      result = result & S2__ee_wrbyte(self, (addr + i), data);
      i = i + _step__0004;
    } while (((_step__0004 > 0) && (i <= _limit__0003)) || ((_step__0004 < 0) && (i >= _limit__0003)));
  }
  result = result & S2__ee_wrbyte(self, (addr + size), (csum & 0xff));
  return result;
}

static int32_t S2__ee_rdbyte(S2 *self, int32_t addr)
{
  int32_t result = 0;
  /*  Read a byte of data from the EEPROM at `addr.  */
  S2__i2c_waddr(self, addr);
  S2__i2c_start(self);
  S2__i2c_wr(self, 163);
  result = S2__i2c_rd(self, NAK);
  S2__i2c_stop(self);
  return result;
}

static int32_t S2__ee_wrbyte(S2 *self, int32_t addr, int32_t data)
{
  int32_t result = 0;
  /*  Write the byte given by `data to the EEPROM at `addr.  */
  S2__i2c_waddr(self, addr);
  result = S2__i2c_wr(self, data);
  S2__i2c_stop(self);
  return result;
}

static int32_t S2__i2c_waddr(S2 *self, int32_t addr)
{
  /*  Work routine for EEPROM. Wait for EEPROM ready, then write a command, followed by the `addr byte.  */
  do {
    S2__i2c_start(self);
  } while (!(S2__i2c_wr(self, 162)));
  S2__i2c_wr(self, (Shr__(addr, 8)));
  S2__i2c_wr(self, (addr & 0xff));
  return 0;
}

static int32_t S2__i2c_rd(S2 *self, int32_t acknak)
{
  int32_t result = 0;
  /*  Work routine for EEPROM. Read the next byte, and send ACK or NAK, depending on `acknak.  */
  {
    int32_t _idx__0005;
    for(_idx__0005 = 1; _idx__0005 <= 8; _idx__0005 = _idx__0005 + 1) {
      OUTA = ((OUTA & 0xefffffff) | 0x10000000);
      result = (result << 1) | ((INA >> SDA) & 0x1);
      OUTA &= ~(1<<SCL);
    }
  }
  DIRA = ((DIRA & 0xdfffffff) | ((-(acknak != 0) & 0x1) << SDA));
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  OUTA &= ~(1<<SCL);
  DIRA &= ~(1<<SDA);
  return result;
}

static int32_t S2__i2c_wr(S2 *self, int32_t data)
{
  int32_t result = 0;
  /*  Work routine for EEPROM. Write the next byte, given by data, and return `true for ACK, `false for NAK.  */
  {
    int32_t _idx__0006;
    for(_idx__0006 = 1; _idx__0006 <= 8; _idx__0006 = _idx__0006 + 1) {
      DIRA = ((DIRA & 0xdfffffff) | ((-(((data = data << 1) & 0x100) == 0) & 0x1) << SDA));
      OUTA = ((OUTA & 0xefffffff) | 0x10000000);
      OUTA &= ~(1<<SCL);
    }
  }
  DIRA &= ~(1<<SDA);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  result = -(((INA >> SDA) & 0x1) == 0);
  OUTA &= ~(1<<SCL);
  return result;
}

static int32_t S2__i2c_start(S2 *self)
{
  /*  Set up an I2C `start condition.  */
  DIRA &= ~(1<<SDA);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  DIRA = ((DIRA & 0xdfffffff) | 0x20000000);
  OUTA &= ~(1<<SCL);
  return 0;
}

static int32_t S2__i2c_stop(S2 *self)
{
  /*  Set up an I2C `stop condition.  */
  OUTA &= ~(1<<SCL);
  DIRA = ((DIRA & 0xdfffffff) | 0x20000000);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  DIRA &= ~(1<<SDA);
  return 0;
}

// Current velocity.
// =======[ License ]===========================================================
/* {
┌──────────────────────────────────────────────────────────────────────────────────────┐
│                            TERMS OF USE: MIT License                                 │                                                            
├──────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this  │
│software and associated documentation files (the "Software"), to deal in the Software │
│without restriction, including without limitation the rights to use, copy, modify,    │
│merge, publish, distribute, sublicense, and/or sell copies of the Software, and to    │
│permit persons to whom the Software is furnished to do so, subject to the following   │
│conditions:                                                                           │
│                                                                                      │
│The above copyright notice and this permission notice shall be included in all copies │
│or substantial portions of the Software.                                              │
│                                                                                      │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,   │
│INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A         │
│PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT    │
│HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF  │
│CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE  │
│OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                                         │
└──────────────────────────────────────────────────────────────────────────────────────┘
 */
