//
// automatically generated by spin2cpp v1.92 on Tue Apr 21 11:27:35 2015
// spin2cpp --main --ccode HokeyPokey.spin 
//

#ifndef S2_Class_Defined__
#define S2_Class_Defined__

#include <stdint.h>

// -[ Version, etc. ]-
/*  Version numbers and miscellaneous other constants.  */
// Major version ID.
#define VERSION (1)
// Minor version ID.
#define SUBVERSION ('Q')
// Sets the size of the sound buffer (words).
#define _TONE_Q_SIZE (1200)
#define NO_CHANGE ((-1))
#define FOREVER (2147483647)
#define UNDEF ((int32_t)0x80000000U)
#define ACK (-1)
#define NAK (0)
#define CNT_IDLER (16)
// -[ Propeller pins ]-
/*  Port names for pins A0 through A31.  */
// Hacker ports 0 - 5.
#define P0 (0)
#define P1 (1)
#define P2 (2)
#define P3 (3)
#define P4 (4)
#define P5 (5)
// Output to left obstacle IRED.
#define OBS_TX_LEFT (6)
// Output to LED shift register data pin.
#define LED_DATA (7)
// Output to LED shift register clock pin.
#define LED_CLK (8)
// Output (feedback) for microphone sigma-delta ADC.
#define MIC_ADC_OUT (9)
// Input for microphone sigma-delta ADC.
#define MIC_ADC_IN (10)
// Input for pushbutton.
#define BUTTON (11)
// Output to idler wheel encoder IRED.
#define IDLER_TX (12)
// Input from left motor encoder.
#define MOT_LEFT_ENC (13)
// Input from right motor encoder.
#define MOT_RIGHT_ENC (14)
// Output to right obstacle IRED.
#define OBS_TX_RIGHT (15)
// Output to left motor controller direction pin.
#define MOT_LEFT_DIR (16)
// Output to right motor controller direction pin.
#define MOT_RIGHT_DIR (17)
// Output to left motor controller PWM pin.
#define MOT_LEFT_PWM (18)
// Output to right motor controller PWM pin.
#define MOT_RIGHT_PWM (19)
// Input from obstacle detector IR receiver.
#define OBS_RX (20)
// Output to speaker amplifier.
#define SPEAKER (21)
// Outputs to analog multiplexer address pins.
#define MUX0 (22)
#define MUX1 (23)
#define MUX2 (24)
#define MUX3 (25)
// Output (feedback) from main sigma-delta ADC.
#define _MUX_ADC_OUT (26)
// Input to main sigma-delta ADC.
#define _MUX_ADC_IN (27)
// Output clock to EEPROMs.
#define SCL (28)
// Input/Output data from/to EEPROMs.
#define SDA (29)
// Output to RS232.
#define TX (30)
// Input from RS232.
#define RX (31)
// -[ EEPROM addresses ]-
/*  These are address pointers into the auxiliary EEPROM, used for storing calibration data,
     button-press counts, and user data. 
 */
// Base address for EEPROM data area.
#define EE_BASE (0)
// [1 byte]  Reset count address.
#define EE_RESET_CNT ((EE_BASE + 0))
// [5 bytes] Wheel calibration data.
#define EE_WHEEL_CALIB ((EE_BASE + 1))
// [4 bytes] Light sensor calibration data.
#define EE_LIGHT_CALIB ((EE_BASE + 6))
// [2 bytes] Line sensor threshold data.
#define EE_LINE_THLD ((EE_BASE + 10))
// [2 bytes] Obstacle threshold data.
#define EE_OBSTACLE_THLD ((EE_BASE + 12))
// Beginning of unreserved user area.
#define EE_USER_AREA ((EE_BASE + 1024))
// -[ Default values ]-
/*  These values are assigned to their respective variables on startup, unless overriding values are stored
     in EEPROM. 
 */
#define DEFAULT_FULL_CIRCLE (955)
#define DEFAULT_WHEEL_SPACE (153)
#define DEFAULT_LIGHT_SCALE (0)
#define DEFAULT_LINE_THLD (32)
#define DEFAULT_OBSTACLE_THLD (20)
// -[ Motor constants ]-
/*  Command, status bits, and indices into the motor debug array.  */
// Command bits:
// Sets immediate (preemptive) mode for motor command.
#define MOT_IMM (1)
// Sets continuous (non-distance) mode for motor command.
#define MOT_CONT (2)
// Sets timeout mode for motor command.
#define MOT_TIMED (4)
// Status bits:
#define MOT_RUNNING (1)
#define MOT_STOPPED (0)
// Debug indices:
// These are indices into the motor debug array.
// Offsets are in bytes counting from @Motor_stat.
// The prefix indicates size of each value (Byte, Word, Long)
// All four control velocities.                                   
#define L_ALL_VEL (4)
// Target velocity.                        
#define B_TARG_VEL (4)
// Current (measured) velocity.
#define B_CUR_VEL (5)
// End velocity for this stroke.
#define B_END_VEL (6)
// Maximum velocity for this stroke.
#define B_MAX_VEL (7)
// Both left and right stroke distances.
#define L_BOTH_DIST (8)
// Right stroke distance.
#define W_RIGHT_DIST (8)
// Left stroke distance.
#define W_LEFT_DIST (10)
// Right coordinated countdown value.
#define L_RIGHT_COUNT (12)
// Left coordinated countdown value.
#define L_LEFT_COUNT (16)
// Dominant distance and count.
#define L_DOM (20)
// Total distance for dominant wheel to travel.
#define W_DOM_DIST (20)
// Distance the dominant wheel has traveled.
#define W_DOM_COUNT (22)

typedef struct S2 {
  char dummy__;
} S2;

  int32_t S2_start_motors( S2 *self );
  int32_t S2_begin_path( S2 *self );
  int32_t S2_end_path( S2 *self );
  int32_t S2_set_speed( S2 *self, int32_t spd);
  int32_t S2_move_to( S2 *self, int32_t x, int32_t y);
  int32_t S2_arc_to( S2 *self, int32_t x, int32_t y, int32_t radius);
  int32_t S2_move_by( S2 *self, int32_t dx, int32_t dy);
  int32_t S2_arc_by( S2 *self, int32_t dx, int32_t dy, int32_t radius);
  int32_t S2_align_with( S2 *self, int32_t heading);
  int32_t S2_turn_to_deg( S2 *self, int32_t heading);
  int32_t S2_turn_to( S2 *self, int32_t heading);
  int32_t S2_turn_by_deg( S2 *self, int32_t dw);
  int32_t S2_turn_by( S2 *self, int32_t dw);
  int32_t S2_here_is( S2 *self, int32_t x, int32_t y);
  int32_t S2_heading_is_deg( S2 *self, int32_t w);
  int32_t S2_heading_is( S2 *self, int32_t w);
  int32_t S2_read_wheel_calibration( S2 *self );
  int32_t S2_write_wheel_calibration( S2 *self );
  int32_t S2_default_wheel_calibration( S2 *self );
  int32_t S2_set_wheel_calibration( S2 *self, int32_t circle, int32_t space);
  int32_t S2_get_wheel_calibration( S2 *self );
  int32_t S2_go_left( S2 *self, int32_t dist);
  int32_t S2_go_right( S2 *self, int32_t dist);
  int32_t S2_go_forward( S2 *self, int32_t dist);
  int32_t S2_go_back( S2 *self, int32_t dist);
  int32_t S2_turn_deg( S2 *self, int32_t ccw_degrees);
  int32_t S2_arc_deg( S2 *self, int32_t ccw_degrees, int32_t radius);
  int32_t S2_turn( S2 *self, int32_t ccw_units);
  int32_t S2_arc( S2 *self, int32_t ccw_units, int32_t radius);
  int32_t S2_turn_deg_now( S2 *self, int32_t ccw_degrees);
  int32_t S2_arc_deg_now( S2 *self, int32_t ccw_degrees, int32_t radius);
  int32_t S2_turn_now( S2 *self, int32_t ccw_units);
  int32_t S2_arc_now( S2 *self, int32_t ccw_units, int32_t radius);
  int32_t S2_move( S2 *self, int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop);
  int32_t S2_wheels_now( S2 *self, int32_t left_velocity, int32_t right_velocity, int32_t move_time);
  int32_t S2_move_now( S2 *self, int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop);
  int32_t S2_stop_now( S2 *self );
  int32_t S2_wait_stop( S2 *self );
  int32_t S2_moving( S2 *self );
  int32_t S2_motion( S2 *self );
  int32_t S2_motion_addr( S2 *self );
  int32_t S2_move_ready( S2 *self );
  int32_t S2_run_motors( S2 *self, int32_t command, int32_t left_distance, int32_t right_distance, int32_t timeout, int32_t max_speed, int32_t end_speed);
#endif
