//
// automatically generated by spin2cpp v1.92 on Thu Jun 11 16:07:00 2015
// spin2cpp --main HokeyPokey.spin 
//

#ifndef S2ABL_Class_Defined__
#define S2ABL_Class_Defined__

#include <stdint.h>

class S2ABL {
public:
// -[ Version, etc. ]-
/*  Version numbers and miscellaneous other constants.  */
// Major version ID.
  static const int VERSION = 1;
// Minor version ID.
  static const int SUBVERSION = 'Q';
  static const int NO_CHANGE = (-1);
  static const int FOREVER = 2147483647;
  static const int UNDEF = (int32_t)0x80000000U;
  static const int ACK = -1;
  static const int NAK = 0;
// obstacle sensors, and wheels.
// -[ Button and LEDs ]-
/*  The button constants are used internally for setting and testing button modes.
     The LED constants can be used for turning the LEDs on and off and for setting intensity, blinking, and colors. 
 */
// Button constants:
// Bit selector for button reset enable.
  static const int RST_ENA = 2;
// Bit selector for button reset LED indicator enable.
  static const int LED_ENA = 1;
// LED constants: 
// Applies to all LEDs.
  static const int OFF = 0;
// Apply to red/green LEDs only...
  static const int RED = 240;
  static const int ORANGE = 180;
  static const int YELLOW = 120;
  static const int CHARTREUSE = 75;
  static const int GREEN = 15;
  static const int DIM_RED = 112;
  static const int DIM_GREEN = 7;
  static const int BLINK_RED = 241;
  static const int BLINK_GREEN = 31;
  static const int ALT_RED_GREEN = 255;
// Apply to power LED only...
  static const int BLUE = 240;
  static const int BLINK_BLUE = 241;
  static const int DIM_BLUE = 112;
// -[ Result array indices ]-
/*  These constants can be used to reference the various values in the Results array.  */
  static const int ADC_VSS = 0;
  static const int ADC_VDD = 1;
  static const int ADC_5V = 2;
  static const int ADC_5V_DIV = 3;
  static const int ADC_VBAT = 4;
  static const int ADC_VTRIP = 5;
  static const int ADC_IDD = 6;
  static const int ADC_RIGHT_LGT = 7;
  static const int ADC_CENTER_LGT = 8;
  static const int ADC_LEFT_LGT = 9;
  static const int ADC_RIGHT_LIN = 10;
  static const int ADC_LEFT_LIN = 11;
  static const int ADC_P6 = 12;
  static const int ADC_P7 = 13;
  static const int ADC_IMOT = 14;
  static const int ADC_IDLER = 15;
  static const int CNT_IDLER = 16;
// and 19
  static const int LED_BYTES = 18;
// and 21
  static const int TIMER = 20;
  static const int BUTTON_CNT = 22;
// -[ Propeller pins ]-
/*  Port names for pins A0 through A31.  */
// Output to left obstacle IRED.
  static const int OBS_TX_LEFT = 6;
// Output to LED shift register data pin.
  static const int LED_DATA = 7;
// Output to LED shift register clock pin.
  static const int LED_CLK = 8;
// Output (feedback) for microphone sigma-delta ADC.
  static const int MIC_ADC_OUT = 9;
// Input for microphone sigma-delta ADC.
  static const int MIC_ADC_IN = 10;
// Input for pushbutton.
  static const int BUTTON = 11;
// Output to idler wheel encoder IRED.
  static const int IDLER_TX = 12;
// Input from obstacle detector IR receiver.
  static const int OBS_RX = 20;
// Output to speaker amplifier.
  static const int SPEAKER = 21;
// Outputs to analog multiplexer address pins.
  static const int MUX0 = 22;
  static const int MUX1 = 23;
  static const int MUX2 = 24;
  static const int MUX3 = 25;
// Output (feedback) from main sigma-delta ADC.
  static const int _MUX_ADC_OUT = 26;
// Input to main sigma-delta ADC.
  static const int _MUX_ADC_IN = 27;
// Output clock to EEPROMs.
  static const int SCL = 28;
// Input/Output data from/to EEPROMs.
  static const int SDA = 29;
// Output to RS232.
  static const int TX = 30;
// Input from RS232.
  static const int RX = 31;
// -[ ADC constants ]-
/* These constants pertain to the main sigma-delta analog-to-digital converter. */
// These are the analog multiplexer addresses controlled by pins MUX0 through MUX3.
// Motor current.
  static const int _MUX_IMOT = 0;
// Motor overcurrent threshold.
  static const int _MUX_VTRIP = 1;
// Battery voltage.
  static const int _MUX_VBAT = 2;
// Idler encoder response.
  static const int _MUX_IDLER = 3;
// Vss reference (used for ADC self-calibration).
  static const int _MUX_VSS = 4;
// +2.5V reference(used to measure +5V vs. Vdd).               
  static const int _MUX_5V_DIV = 5;
// +5V reference (used for ADC self-calibration).
  static const int _MUX_5V = 6;
// +3.3V reference (used for ADC self-calibration.)
  static const int _MUX_VDD = 7;
// Hacker port P7 analog input.
  static const int _MUX_P7 = 8;
// Right light sensor.
  static const int _MUX_RIGHT_LGT = 9;
// Center light sensor.
  static const int _MUX_CENTER_LGT = 10;
// Hacker port P6 analog input.
  static const int _MUX_P6 = 11;
// Vdd current.
  static const int _MUX_IDD = 12;
// Left light sensor.
  static const int _MUX_LEFT_LGT = 13;
// Right line sensor.
  static const int _MUX_RIGHT_LIN = 14;
// Left line sensor.
  static const int _MUX_LEFT_LIN = 15;
// These values are used by the ADC sequencer to retrieve analog values and store them
// in their respective array positions.
  static const int _VSS = ((_MUX_VSS << 12) | (ADC_VSS << 8));
  static const int _VDD = ((_MUX_VDD << 12) | (ADC_VDD << 8));
  static const int _5V = ((_MUX_5V << 12) | (ADC_5V << 8));
  static const int _5V_DIV = ((_MUX_5V_DIV << 12) | (ADC_5V_DIV << 8));
  static const int _VBAT = ((_MUX_VBAT << 12) | (ADC_VBAT << 8));
  static const int _IDD = ((_MUX_IDD << 12) | (ADC_IDD << 8));
  static const int _IMOT = ((_MUX_IMOT << 12) | (ADC_IMOT << 8));
  static const int _VTRIP = ((_MUX_VTRIP << 12) | (ADC_VTRIP << 8));
  static const int _IDLER = ((_MUX_IDLER << 12) | (ADC_IDLER << 8));
  static const int _RIGHT_LGT = ((_MUX_RIGHT_LGT << 12) | (ADC_RIGHT_LGT << 8));
  static const int _LEFT_LGT = ((_MUX_LEFT_LGT << 12) | (ADC_LEFT_LGT << 8));
  static const int _CENTER_LGT = ((_MUX_CENTER_LGT << 12) | (ADC_CENTER_LGT << 8));
  static const int _RIGHT_LIN = ((_MUX_RIGHT_LIN << 12) | (ADC_RIGHT_LIN << 8));
  static const int _LEFT_LIN = ((_MUX_LEFT_LIN << 12) | (ADC_LEFT_LIN << 8));
  static const int _P6 = ((_MUX_P6 << 12) | (ADC_P6 << 8));
  static const int _P7 = ((_MUX_P7 << 12) | (ADC_P7 << 8));
// These values are used in the ADC task list to define the precharge time before
// a conversion begins.
  static const int _SOAK_1us = (0 << 4);
  static const int _SOAK_2us = (1 << 4);
  static const int _SOAK_4us = (2 << 4);
  static const int _SOAK_8us = (3 << 4);
  static const int _SOAK_16us = (4 << 4);
  static const int _SOAK_32us = (5 << 4);
  static const int _SOAK_64us = (6 << 4);
  static const int _SOAK_128us = (7 << 4);
  static const int _SOAK_256us = (8 << 4);
  static const int _SOAK_512us = (9 << 4);
  static const int _SOAK_1ms = (10 << 4);
  static const int _SOAK_2ms = (11 << 4);
  static const int _SOAK_4ms = (12 << 4);
  static const int _SOAK_8ms = (13 << 4);
  static const int _SOAK_16ms = (14 << 4);
  static const int _SOAK_32ms = (15 << 4);
// These values are used in the ADC task list to define low-pass filtering time constants.
  static const int _LPF_NONE = (0 << 1);
  static const int _LPF_1ms = (1 << 1);
  static const int _LPF_2ms = (2 << 1);
  static const int _LPF_4ms = (3 << 1);
  static const int _LPF_8ms = (4 << 1);
  static const int _LPF_16ms = (5 << 1);
  static const int _LPF_32ms = (6 << 1);
  static const int _LPF_64ms = (7 << 1);
// These values are used in the ADC task list to define the reference voltage for each reading.
  static const int _REF_3V3 = 0;
  static const int _REF_5V0 = 1;
// -[ EEPROM addresses ]-
/*  These are address pointers into the auxiliary EEPROM, used for storing calibration data,
     button-press counts, and user data. 
 */
// Base address for EEPROM data area.
  static const int EE_BASE = 0;
// [1 byte]  Reset count address.
  static const int EE_RESET_CNT = (EE_BASE + 0);
// [5 bytes] Wheel calibration data.
  static const int EE_WHEEL_CALIB = (EE_BASE + 1);
// [4 bytes] Light sensor calibration data.
  static const int EE_LIGHT_CALIB = (EE_BASE + 6);
// [2 bytes] Line sensor threshold data.
  static const int EE_LINE_THLD = (EE_BASE + 10);
// [2 bytes] Obstacle threshold data.
  static const int EE_OBSTACLE_THLD = (EE_BASE + 12);
// Beginning of unreserved user area.
  static const int EE_USER_AREA = (EE_BASE + 1024);
  static const int NONE = 0;
  static const int LEFT = 1;
  static const int RIGHT = 2;
  static const int CENTER = 3;
// Used with LEDs, light sensors, line sensors,
  static const int POWER = 4;
  static uint8_t dat[];
  int32_t	start(void);
  int32_t	stop_all(void);
  int32_t	get_results(int32_t index);
  int32_t	get_adc_results(int32_t index);
  int32_t	button_mode(int32_t led_enable, int32_t reset_enable);
  int32_t	button_press(void);
  int32_t	button_count(void);
  int32_t	reset_button_count(void);
  int32_t	set_leds(int32_t left_color, int32_t center_color, int32_t right_color, int32_t power_color);
  int32_t	set_led(int32_t index, int32_t color);
  int32_t	delay_tenths(int32_t time);
  int32_t	ee_read_byte(int32_t addr);
  int32_t	ee_write_byte(int32_t addr, int32_t data);
private:
  int32_t	_ee_rdblock(int32_t dest_addr, int32_t addr, int32_t size);
  int32_t	_ee_wrblock(int32_t src_addr, int32_t addr, int32_t size);
  int32_t	_ee_rdbyte(int32_t addr);
  int32_t	_ee_wrbyte(int32_t addr, int32_t data);
  int32_t	_i2c_waddr(int32_t addr);
  int32_t	_i2c_rd(int32_t acknak);
  int32_t	_i2c_wr(int32_t data);
  int32_t	_i2c_start(void);
  int32_t	_i2c_stop(void);
};

#endif
