//
// automatically generated by spin2cpp v1.92 on Thu Jun 11 16:07:00 2015
// spin2cpp --main HokeyPokey.spin 
//

#ifndef S2MotDrv_Class_Defined__
#define S2MotDrv_Class_Defined__

#include <stdint.h>

class S2MotDrv {
public:
// -[ Version, etc. ]-
/*  Version numbers and miscellaneous other constants.  */
// Major version ID.
  static const int VERSION = 1;
// Minor version ID.
  static const int SUBVERSION = 'Q';
//  _TONE_Q_SIZE    = 1200                'Sets the size of the sound buffer (words).
  static const int NO_CHANGE = (-1);
  static const int FOREVER = 2147483647;
  static const int UNDEF = (int32_t)0x80000000U;
  static const int ACK = -1;
  static const int NAK = 0;
// -[ Result array indices ]-
/*  These constants can be used to reference the various values in the Results array.  */
  static const int CNT_IDLER = 16;
// -[ Propeller pins ]-
/*  Port names for pins A0 through A31.  */
// Input from left motor encoder.
  static const int MOT_LEFT_ENC = 13;
// Input from right motor encoder.
  static const int MOT_RIGHT_ENC = 14;
// Output to right obstacle IRED.
  static const int OBS_TX_RIGHT = 15;
// Output to left motor controller direction pin.
  static const int MOT_LEFT_DIR = 16;
// Output to right motor controller direction pin.
  static const int MOT_RIGHT_DIR = 17;
// Output to left motor controller PWM pin.
  static const int MOT_LEFT_PWM = 18;
// Output to right motor controller PWM pin.
  static const int MOT_RIGHT_PWM = 19;
// Output clock to EEPROMs.
  static const int SCL = 28;
// Input/Output data from/to EEPROMs.
  static const int SDA = 29;
// Output to RS232.
  static const int TX = 30;
// Input from RS232.
  static const int RX = 31;
// -[ EEPROM addresses ]-
/*  These are address pointers into the auxiliary EEPROM, used for storing calibration data,
     button-press counts, and user data. 
 */
// Base address for EEPROM data area.
  static const int EE_BASE = 0;
// [1 byte]  Reset count address.
  static const int EE_RESET_CNT = (EE_BASE + 0);
// [5 bytes] Wheel calibration data.
  static const int EE_WHEEL_CALIB = (EE_BASE + 1);
// [4 bytes] Light sensor calibration data.
  static const int EE_LIGHT_CALIB = (EE_BASE + 6);
// [2 bytes] Line sensor threshold data.
  static const int EE_LINE_THLD = (EE_BASE + 10);
// [2 bytes] Obstacle threshold data.
  static const int EE_OBSTACLE_THLD = (EE_BASE + 12);
// Beginning of unreserved user area.
  static const int EE_USER_AREA = (EE_BASE + 1024);
// -[ Default values ]-
/*  These values are assigned to their respective variables on startup, unless overriding values are stored
     in EEPROM. 
 */
  static const int DEFAULT_FULL_CIRCLE = 955;
  static const int DEFAULT_WHEEL_SPACE = 153;
  static const int DEFAULT_LIGHT_SCALE = 0;
  static const int DEFAULT_LINE_THLD = 32;
  static const int DEFAULT_OBSTACLE_THLD = 20;
// -[ Motor constants ]-
/*  Command, status bits, and indices into the motor debug array.  */
// Command bits:
// Sets immediate (preemptive) mode for motor command.
  static const int MOT_IMM = 1;
// Sets continuous (non-distance) mode for motor command.
  static const int MOT_CONT = 2;
// Sets timeout mode for motor command.
  static const int MOT_TIMED = 4;
// Status bits:
  static const int MOT_RUNNING = 1;
  static const int MOT_STOPPED = 0;
  static uint8_t dat[];
  int32_t	start_motors(void);
  int32_t	begin_path(void);
  int32_t	end_path(void);
  int32_t	set_speed(int32_t spd);
  int32_t	move_to(int32_t x, int32_t y);
  int32_t	arc_to(int32_t x, int32_t y, int32_t radius);
  int32_t	move_by(int32_t dx, int32_t dy);
  int32_t	arc_by(int32_t dx, int32_t dy, int32_t radius);
  int32_t	align_with(int32_t heading);
  int32_t	turn_to_deg(int32_t heading);
  int32_t	turn_to(int32_t heading);
  int32_t	turn_by_deg(int32_t dw);
  int32_t	turn_by(int32_t dw);
  int32_t	here_is(int32_t x, int32_t y);
  int32_t	heading_is_deg(int32_t w);
  int32_t	heading_is(int32_t w);
  int32_t	read_wheel_calibration(void);
  int32_t	write_wheel_calibration(void);
  int32_t	default_wheel_calibration(void);
  int32_t	set_wheel_calibration(int32_t circle, int32_t space);
  int32_t	get_wheel_calibration(void);
  int32_t	go_left(int32_t dist);
  int32_t	go_right(int32_t dist);
  int32_t	go_forward(int32_t dist);
  int32_t	go_back(int32_t dist);
  int32_t	turn_deg(int32_t ccw_degrees);
  int32_t	arc_deg(int32_t ccw_degrees, int32_t radius);
  int32_t	turn(int32_t ccw_units);
  int32_t	arc(int32_t ccw_units, int32_t radius);
  int32_t	turn_deg_now(int32_t ccw_degrees);
  int32_t	arc_deg_now(int32_t ccw_degrees, int32_t radius);
  int32_t	turn_now(int32_t ccw_units);
  int32_t	arc_now(int32_t ccw_units, int32_t radius);
  int32_t	move(int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop);
  int32_t	wheels_now(int32_t left_velocity, int32_t right_velocity, int32_t move_time);
  int32_t	move_now(int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop);
  int32_t	stop_now(void);
  int32_t	wait_stop(void);
  int32_t	moving(void);
  int32_t	motion(void);
  int32_t	motion_addr(void);
  int32_t	move_ready(void);
  int32_t	run_motors(int32_t command, int32_t left_distance, int32_t right_distance, int32_t timeout, int32_t max_speed, int32_t end_speed);
private:
  int32_t	_compute_calibration(void);
  int32_t	_atan2(int32_t y, int32_t x);
  int32_t	_ee_rdblock(int32_t dest_addr, int32_t addr, int32_t size);
  int32_t	_ee_wrblock(int32_t src_addr, int32_t addr, int32_t size);
  int32_t	_ee_rdbyte(int32_t addr);
  int32_t	_ee_wrbyte(int32_t addr, int32_t data);
  int32_t	_i2c_waddr(int32_t addr);
  int32_t	_i2c_rd(int32_t acknak);
  int32_t	_i2c_wr(int32_t data);
  int32_t	_i2c_start(void);
  int32_t	_i2c_stop(void);
};

#endif
